//////////////////////////////////////////////////////////////////////////////
// ** PORTSCAN - Win32 application to obtain host info and scan IP ports **
// THIS SOFTWARE IS Copyright 1998 by Bob Frazier - All rights reserved
// It has been provided to the public as "copy-left" according to the terms
// of the GNU GENERAL PUBLIC LICENSE at http://www.gnu.org/copyleft/gpl.html
//
// THIS CODE IS PROVIDED 'AS-IS' with NO WARRANTEE WHATSOEVER
// USE IT AT YOUR OWN RISK - Bob Frazier CLAIMS NO RESPONSIBILITY FOR
// ANY DAMAGES, CONSEQUENTIAL OR OTHERWISE, THAT MAY RESULT FROM
// USE OR ABUSE OF THIS PROGRAM, WHETHER IN ITS ORIGINAL OR MODIFIED STATE.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// For a copy of the GNU General Public License, you can visit the
// 'gnu.org' web site at http://www.gnu.org/, or write to the
// Free Software Foundation, Inc.
// 59 Temple Place - Suite 330
// Boston, MA  02111-1307, USA.
//////////////////////////////////////////////////////////////////////////////
// SockThread.cpp : implementation file
//

#include "stdafx.h"
#include "portscan.h"
#include "SockThread.h"
#include "PortScanDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// bug fixes - from SOCKCORE.CPP
#define _afxSockThreadState AfxGetModuleThreadState()
#define _AFX_SOCK_THREAD_STATE AFX_MODULE_THREAD_STATE


/////////////////////////////////////////////////////////////////////////////
// CSockThread

IMPLEMENT_DYNCREATE(CSockThread, CWinThread)

CSockThread::CSockThread()
{
}

CSockThread::~CSockThread()
{
}

BOOL CSockThread::InitInstance()
{

//  if(!AfxSocketInit())
//  {
//    return(FALSE);
//  }

  // initialize Winsock library (from AfxSocketInit - bug, must inline it here)

	WSADATA wsaData;

	WORD wVersionRequested = MAKEWORD(1, 1);
	int nResult = WSAStartup(wVersionRequested, &wsaData);
	if (nResult != 0)
		return FALSE;

	if (LOBYTE(wsaData.wVersion) != 1 || HIBYTE(wsaData.wVersion) != 1)
	{
		WSACleanup();
		return FALSE;
	}

//	_AFX_SOCK_THREAD_STATE* pState = _afxSockThreadState;
//	if (pState->m_pmapSocketHandle == NULL)
//		pState->m_pmapSocketHandle = new CMapPtrToPtr;
//	if (pState->m_pmapDeadSockets == NULL)
//		pState->m_pmapDeadSockets = new CMapPtrToPtr;
//	if (pState->m_plistSocketNotifications == NULL)
//		pState->m_plistSocketNotifications = new CPtrList;

  /*PostQuitMessage(*/ ScanThreadProc(); // );

  WSACleanup();

	return(TRUE);  // this will do what I want
}

int CSockThread::ExitInstance()
{
	return CWinThread::ExitInstance();
}

BEGIN_MESSAGE_MAP(CSockThread, CWinThread)
	//{{AFX_MSG_MAP(CSockThread)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSockThread message handlers

class CScanThreadClass
{
public:
  CScanThreadClass() { m_bQuit = FALSE; CPortscanDlg::AddThread(AfxGetThread()); }
  ~CScanThreadClass() { CPortscanDlg::EndThread(AfxGetThread()); }

  BOOL KeepRunning()
  { MSG msg; if(m_bQuit) return(FALSE);
    if(::PeekMessage(&msg, NULL, WM_QUIT, WM_QUIT, PM_REMOVE))
    { m_bQuit = TRUE;  return(FALSE); }
    return(TRUE);
  }

protected:

  BOOL m_bQuit;
};

UINT CSockThread::ScanThreadProc()
{
CScanThreadClass stc;  // auto-registers me with dialog box, helps kill thread


//  CSocket sock;

  SOCKET s = socket(PF_INET, SOCK_STREAM, 0);  // that's the way MFC does it

  if(s == INVALID_SOCKET)
  {
    AfxMessageBox("SOCKET limit reached - cannot create new socket.\r\n"
                  "Reduce the maximum # of threads by changing the THREAD_COUNT "
                  "define in 'portscandlg.cpp' and re-compile.");

    return(-1);
  }

  int i1, i2, i3, i4, i5;

  int iSockIncr1 = 1, iSockIncr2 = 1, iSockIncr3 = 1, iSockIncr4 = 1;
  int iSockStart1 = 0, iSockStart2 = 0, iSockStart3 = 0, iSockStart4 = 0;

  BOOL bScanPort = TRUE;
  BOOL bScanIP = FALSE;

  if(m_iPort >= 0)
  {
    bScanPort = FALSE;
  }

  if(m_aIP[0] < 0 || m_aIP[1] < 0 ||
     m_aIP[2] < 0 || m_aIP[3] < 0)
  {
    bScanIP = TRUE;

    // determine which part of the IP address gets 'm_iIncr' and 'm_iMask'
    // whenever I'm scanning IP's

    if(m_aIP[3] < 0)
    {
      iSockIncr4 = m_iIncr;
      iSockStart4 = m_iMask;
    }
    else if(m_aIP[2] < 0)
    {
      iSockIncr3 = m_iIncr;
      iSockStart3 = m_iMask;
    }
    else if(m_aIP[1] < 0)
    {
      iSockIncr2 = m_iIncr;
      iSockStart2 = m_iMask;
    }
    else // if(m_aIP[0] < 0)
    {
      iSockIncr1 = m_iIncr;  // here it really doesn't matter if it's zero or not
      iSockStart1 = m_iMask;
    }
  }

  for(i1 = (m_aIP[0] >= 0 ? m_aIP[0] : iSockStart1);
      stc.KeepRunning() && i1 < 256 && (i1 == m_aIP[0] || m_aIP[0] < 0); i1 += iSockIncr1)
  {
    for(i2 = (m_aIP[1] >= 0 ? m_aIP[1] : iSockStart2);
        stc.KeepRunning() && i2 < 256 && (i2 == m_aIP[1] || m_aIP[1] < 0); i2 += iSockIncr2)
    {
      for(i3 = (m_aIP[2] >= 0 ? m_aIP[2] : iSockStart3);
          stc.KeepRunning() && i3 < 256 && (i3 == m_aIP[2] || m_aIP[2] < 0); i3 += iSockIncr3)
      {
        for(i4 = (m_aIP[3] >= 0 ? m_aIP[3] : iSockStart4);
            stc.KeepRunning() && i4 < 256 && (i4 == m_aIP[3] || m_aIP[3] < 0); i4 += iSockIncr4)
        {
          for(i5 = (m_iPort >= 0 ? m_iPort : m_iMask);
              stc.KeepRunning() && i5 < 65536 && (i5 == m_iPort || m_iPort < 0);
              i5 += m_iIncr)
          {
            CString csTemp, csTemp2;

            if(bScanPort)
            {
              csTemp.Format("%d", i5);
            }
            else
            {
              csTemp.Format("%d.%d.%d.%d", i1, i2, i3, i4);
            }

            ::SetDlgItemText(theApp.m_pMainWnd->GetSafeHwnd(),
                             IDC_STATUS, (LPCSTR)csTemp);

            // here's where the fun begins

            SOCKADDR_IN sa;
            memset(&sa, 0, sizeof(sa));

            sa.sin_port = htons(i5);
            sa.sin_family = AF_INET;

            sa.sin_addr.S_un.S_un_b.s_b1 = (BYTE)i1;
            sa.sin_addr.S_un.S_un_b.s_b2 = (BYTE)i2;
            sa.sin_addr.S_un.S_un_b.s_b3 = (BYTE)i3;
            sa.sin_addr.S_un.S_un_b.s_b4 = (BYTE)i4;

            if(!connect(s, (SOCKADDR *)&sa, sizeof(sa)))
//            if(sock.Connect((SOCKADDR *)&sa, sizeof(sa)))
            {
              if(bScanIP)
              {
                csTemp.Format("%03d.%03d.%03d.%03d", i1, i2, i3, i4);

                if(bScanPort)
                  csTemp += "   ";
              }
              else
              {
                csTemp = "";
              }

              if(bScanPort)
              {
                csTemp2.Format("%6d", i5);  // make sure it has lead white space

                servent *lpS = getservbyport(htons(i5), NULL);

                if(lpS && lpS->s_name)
                  csTemp2 += "   " + (CString)lpS->s_name;
                else if(i5 == 7)
                  csTemp2 += "   echo";
                else if(i5 == 9)
                  csTemp2 += "   discard";
                else if(i5 == 13)
                  csTemp2 += "   daytime";
                else if(i5 == 17)
                  csTemp2 += "   qotd";
                else if(i5 == 19)
                  csTemp2 += "   chargen";
                else if(i5 == 21)
                  csTemp2 += "   ftp";
                else if(i5 == 22)
                  csTemp2 += "   erm";
                else if(i5 == 23)
                  csTemp2 += "   telnet";
                else if(i5 == 25)
                  csTemp2 += "   smtp";
                else if(i5 == 79)
                  csTemp2 += "   finger";
                else if(i5 == 80)
                  csTemp2 += "   www-http";
                else if(i5 == 110)
                  csTemp2 += "   pop3";
                else if(i5 == 119)
                  csTemp2 += "   nntp";
                else if(i5 == 135)
                  csTemp2 += "   loc-srv";
                else if(i5 == 139)
                  csTemp2 += "   nbsession";
                else if(i5 == 443)
                  csTemp2 += "   https";
                else if(i5 == 569)
                  csTemp2 += "   MSN";
                else if(i5 == 1080)
                  csTemp2 += "   socks";
              }
              else
              {
                csTemp2 = "";
              }

              csTemp += csTemp2;

              TRACE0(csTemp + "\r\n");

              ::SendDlgItemMessage(theApp.m_pMainWnd->GetSafeHwnd(),
                                   IDC_LIST, LB_ADDSTRING, (WPARAM)0,
                                   (LPARAM)(LPCSTR)csTemp);

              closesocket(s);
//              sock.Close();

//              if(!sock.Create())
              s = socket(PF_INET, SOCK_STREAM, 0);  // that's the way MFC does it
              if(s == INVALID_SOCKET)
              {
                AfxMessageBox("SOCKET limit reached - cannot create new socket.\r\n"
                              "Reduce the maximum # of threads by changing the THREAD_COUNT "
                              "define in 'portscandlg.cpp' and re-compile.");

                return(-1);
              }
            }

          }
        }
      }
    }
  }

//  sock.Close();
  if(s != INVALID_SOCKET)
    closesocket(s);

  return(0);
}


