//////////////////////////////////////////////////////////////////////////////
// ** PORTSCAN - Win32 application to obtain host info and scan IP ports **
// THIS SOFTWARE IS Copyright 1998 by Bob Frazier - All rights reserved
// It has been provided to the public as "copy-left" according to the terms
// of the GNU GENERAL PUBLIC LICENSE at http://www.gnu.org/copyleft/gpl.html
//
// THIS CODE IS PROVIDED 'AS-IS' with NO WARRANTEE WHATSOEVER
// USE IT AT YOUR OWN RISK - Bob Frazier CLAIMS NO RESPONSIBILITY FOR
// ANY DAMAGES, CONSEQUENTIAL OR OTHERWISE, THAT MAY RESULT FROM
// USE OR ABUSE OF THIS PROGRAM, WHETHER IN ITS ORIGINAL OR MODIFIED STATE.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// For a copy of the GNU General Public License, you can visit the
// 'gnu.org' web site at http://www.gnu.org/, or write to the
// Free Software Foundation, Inc.
// 59 Temple Place - Suite 330
// Boston, MA  02111-1307, USA.
//////////////////////////////////////////////////////////////////////////////
// InetAddress.h : header file
//

#if !defined(AFX_INETADDRESS_H__3D4CE3A4_649E_11D2_A3F7_004033901FF3__INCLUDED_)
#define AFX_INETADDRESS_H__3D4CE3A4_649E_11D2_A3F7_004033901FF3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


/////////////////////////////////////////////////////////////////////////////
// CInetAddress

// use array operator for multiple aliases - or cast to 'SOCADDR_IN' directly
// constructor takes generic inet address and optional default port #

class CInetAddress : public CObject, public SOCKADDR_IN
{
public:
  DECLARE_DYNAMIC(CInetAddress);

  CInetAddress(LPCSTR szAddr, UINT uiDefPort=0);  // server:port
  virtual ~CInetAddress();

  BOOL IsValid()              // indicates no error in constructor
  { return(m_bIsValid); }
  CString GetAddress()   // as specified in constructor with port
  { return(m_csAddr); }
  CString GetName()
  { return(m_csName); }
  CString GetAlias()     // obtained by 'gethostbyaddr'
  { return(m_csAlias); }

  int GetDimensions()
  { return(1 + m_aAlternates.GetSize()); }

  SOCKADDR_IN operator [] (int iIndex);

  static BOOL IsAddress(LPCSTR szAddr);  // TRUE if #.#.#.#; false otherwise
  static BOOL GetAddress(LPCSTR szAddr, char cAddr[4]);

  static BOOL IsAddressRange(LPCSTR szAddr);  // TRUE if #.#.#.# with asterisks
  static BOOL GetAddressRange(LPCSTR szAddr, int cAddr[4]);

protected: 

  CArray<SOCKADDR_IN,SOCKADDR_IN &> m_aAlternates;

  BOOL m_bIsValid;

  CString m_csAddr;
  CString m_csName;  // official name (from HOSTENT)
  CString m_csAlias; // 1st alias (from HOSTENT)
};


#endif // AFX_INETADDRESS_H__3D4CE3A4_649E_11D2_A3F7_004033901FF3__INCLUDED_

