//////////////////////////////////////////////////////////////////////////////
// ** PORTSCAN - Win32 application to obtain host info and scan IP ports **
// THIS SOFTWARE IS Copyright 1998 by Bob Frazier - All rights reserved
// It has been provided to the public as "copy-left" according to the terms
// of the GNU GENERAL PUBLIC LICENSE at http://www.gnu.org/copyleft/gpl.html
//
// THIS CODE IS PROVIDED 'AS-IS' with NO WARRANTEE WHATSOEVER
// USE IT AT YOUR OWN RISK - Bob Frazier CLAIMS NO RESPONSIBILITY FOR
// ANY DAMAGES, CONSEQUENTIAL OR OTHERWISE, THAT MAY RESULT FROM
// USE OR ABUSE OF THIS PROGRAM, WHETHER IN ITS ORIGINAL OR MODIFIED STATE.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// For a copy of the GNU General Public License, you can visit the
// 'gnu.org' web site at http://www.gnu.org/, or write to the
// Free Software Foundation, Inc.
// 59 Temple Place - Suite 330
// Boston, MA  02111-1307, USA.
//////////////////////////////////////////////////////////////////////////////
// portscanDlg.h : header file
//

#if !defined(AFX_PORTSCANDLG_H__8784EA58_6A18_11D2_A3FA_004033901FF3__INCLUDED_)
#define AFX_PORTSCANDLG_H__8784EA58_6A18_11D2_A3FA_004033901FF3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CPortscanDlg dialog

class CPortscanDlg : public CDialog
{
// Construction
public:
	CPortscanDlg(CWnd* pParent = NULL);	// standard constructor

  static CMutex m_Mutex;  // for synchronization
  static CArray<CWinThread *,CWinThread *> m_aThreads;  // current array of threads

  static void AddThread(CWinThread *);
  static void EndThread(CWinThread *);

  CFont m_Font;

// Dialog Data
	//{{AFX_DATA(CPortscanDlg)
	enum { IDD = IDD_PORTSCAN_DIALOG };
	CComboBox	m_wndThreadCount;
	CButton	m_btnExit;
	CButton	m_btnScan;
	CButton	m_btnHelp;
	CButton	m_btnCancel;
	CButton	m_btnSave;
	CListBox	m_wndList;
	CString	m_csIPPort;
	int		m_iType;
	CString	m_csStatus;
	int		m_iThreadCount;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPortscanDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CPortscanDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnHelp();
	afx_msg void OnSave();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnExit();
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	//}}AFX_MSG

  afx_msg LRESULT OnThreadExit(WPARAM,LPARAM);

	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PORTSCANDLG_H__8784EA58_6A18_11D2_A3FA_004033901FF3__INCLUDED_)
